<template>
  <div class="role-manage">
    <div class="part-box part-box-filter part-box-flex">
      <el-form ref="FilterForm" label-position="left" label-width="85px" inline>
        <template v-if="checkPrivilege('condition', 'condition')">
          <el-form-item label="角色名称：">
            <el-input
              style="width: 200px"
              v-model.trim="filter.name"
              placeholder="角色名称"
              clearable
            ></el-input>
          </el-form-item>
          <!-- <el-form-item label="启用/禁用：" label-width="90px">
          <el-select
            v-model="filter.enable"
            style="width: 120px;"
            placeholder="请选择"
            clearable
          >
            <el-option
              v-for="(val, key) in ABLE_TYPE"
              :key="key"
              :value="key * 1"
              :label="val"
            ></el-option>
          </el-select>
        </el-form-item> -->
        </template>
        <el-form-item>
          <el-button
            v-if="checkPrivilege('button', 'select')"
            type="primary"
            @click="toPage(1)"
            >查询</el-button
          >
        </el-form-item>
      </el-form>
      <div class="part-box-action">
        <el-button
          v-if="checkPrivilege('button', 'add')"
          type="primary"
          icon="el-icon-circle-plus-outline"
          @click="toAdd"
          >新增</el-button
        >
      </div>
    </div>
    <div class="part-box part-box-pad">
      <el-table ref="TableList" :data="roles">
        <el-table-column
          type="index"
          label="序号"
          width="70"
          :index="indexMethod"
        ></el-table-column>
        <el-table-column prop="name" label="角色名称"></el-table-column>
        <!-- <el-table-column prop="enable" label="启用/禁用">
          <template slot-scope="scope">
            {{ scope.row.enable | enableFilter }}
          </template>
        </el-table-column> -->
        <el-table-column prop="interpret" label="角色说明"></el-table-column>
        <el-table-column prop="createTime" label="创建时间" width="170">
          <span slot-scope="scope">{{
            scope.row.createTime | timestampFilter
          }}</span>
        </el-table-column>
        <el-table-column class-name="action-column" label="操作" width="180px">
          <template slot-scope="scope">
            <el-button
              v-if="checkPrivilege('link', 'edit') && !scope.row.defaultRole"
              class="btn-primary"
              type="text"
              @click="toEdit(scope.row)"
              >编辑</el-button
            >
            <el-button
              v-if="scope.row.defaultRole"
              class="btn-primary"
              type="text"
              @click="toView(scope.row)"
              >查看</el-button
            >
            <el-button
              v-if="checkPrivilege('link', 'Manager')"
              class="btn-primary"
              type="text"
              @click="toEditUser(scope.row)"
              >成员管理</el-button
            >
            <el-button
              v-if="checkPrivilege('link', 'delete') && !scope.row.defaultRole"
              class="btn-danger"
              type="text"
              @click="toDelete(scope.row)"
              >删除</el-button
            >
            <!-- <el-button
              v-if="checkPrivilege('link', 'enable')"
              :class="scope.row.enable ? 'btn-danger' : 'btn-primary'"
              type="text"
              @click="toEnable(scope.row)"
              >{{ scope.row.enable ? "禁用" : "启用" }}</el-button
            > -->
          </template>
        </el-table-column>
      </el-table>
      <div class="part-page">
        <el-pagination
          background
          layout="total, sizes, prev, pager, next, jumper"
          :pager-count="5"
          :current-page="current"
          :total="total"
          :page-size="size"
          @current-change="toPage"
          @size-change="pageSizeChange"
        >
        </el-pagination>
      </div>
    </div>
    <!-- ModifyRole -->
    <modify-role
      v-if="checkPrivilege('button', 'add') || checkPrivilege('link', 'edit')"
      ref="ModifyRole"
      :instance="curRole"
      :view-mode="viewMode"
      @modified="getList"
    ></modify-role>
    <!-- ModifyRoleUser -->
    <modify-role-user ref="ModifyRoleUser" :role="curRole"></modify-role-user>
  </div>
</template>

<script>
import { ABLE_TYPE } from "@/constants/enumerate";
import { roleListPage, ableRole, deleteRole } from "../api";
import ModifyRole from "../components/ModifyRole.vue";
import ModifyRoleUser from "../components/ModifyRoleUser.vue";

export default {
  name: "role-manage",
  components: {
    ModifyRole,
    ModifyRoleUser,
  },
  data() {
    return {
      filter: {
        enable: null,
        name: "",
      },
      current: 1,
      size: this.GLOBAL.pageSize,
      total: 0,
      roles: [],
      curRole: {},
      ABLE_TYPE,
      ROLE_TYPE: {},
      viewMode: false,
    };
  },
  mounted() {
    this.toPage(1);
  },
  methods: {
    async getList() {
      if (!this.checkPrivilege("list", "list")) return;

      const datas = {
        ...this.filter,
        pageNumber: this.current,
        pageSize: this.size,
      };
      if (datas.enable !== null && datas.enable !== "")
        datas.enable = !!datas.enable;
      const data = await roleListPage(datas);
      this.roles = data.records;
      this.total = data.total;
    },
    toPage(page) {
      this.current = page;
      this.getList();
    },
    toAdd() {
      this.curRole = {};
      this.viewMode = false;
      this.$refs.ModifyRole.open();
    },
    toEdit(row) {
      this.curRole = row;
      this.viewMode = false;
      this.$refs.ModifyRole.open();
    },
    toView(row) {
      this.curRole = row;
      this.viewMode = true;
      this.$refs.ModifyRole.open();
    },
    toEditUser(row) {
      console.log(row);
      this.curRole = row;
      this.$refs.ModifyRoleUser.open();
    },
    toDelete(row) {
      this.$confirm(`确定要删除角色【${row.name}】吗?`, "提示", {
        type: "warning",
      })
        .then(async () => {
          await deleteRole(row.id);
          this.$message.success("删除成功！");
          this.deletePageLastItem();
        })
        .catch(() => {});
    },
    toEnable(row) {
      const action = row.enable ? "禁用" : "启用";

      this.$confirm(`确定要${action}角色【${row.name}】吗?`, "提示", {
        type: "warning",
      })
        .then(async () => {
          const enable = !row.enable;
          await ableRole({
            id: row.id,
            enable,
          });
          row.enable = enable;
          this.$message.success("操作成功！");
        })
        .catch(() => {});
    },
  },
};
</script>
